
// xkey.cxx

#include "xdelete.h"
#include <conio.h>

extern BOOL please_NO_confirmation; // FIX20080906 added "-NO-confirmation-please"

#define  VFH(a)   ( a && ( a != INVALID_HANDLE_VALUE ) )

int default_wait = 5000;  // ms to to wait
HANDLE ghStdOut = NULL;
HANDLE ghErrOut = NULL;
BOOL  gbRedON = FALSE;  // gotred - got redirection of stdout
BOOL  gbErrON = FALSE;  // got redirection of stderr

void pgm_init( void )
{
   DWORD gdwMode;
   ghStdOut = GetStdHandle( STD_OUTPUT_HANDLE );   // Standard out
   ghErrOut = GetStdHandle( STD_ERROR_HANDLE  );   // error out
   if( VFH(ghStdOut) )
   {
      if( !GetConsoleMode( ghStdOut, &gdwMode ) )
         gbRedON = TRUE;
   }
   if( VFH(ghErrOut) )
   {
      if( !GetConsoleMode( ghErrOut, &gdwMode ) )
         gbErrON = TRUE;
   }
}

int check_key_available( void )
{
   int chr = _kbhit();
   return chr;
}

int get_keyboard_character( void )
{
   int chr, i;
   int   wait = default_wait;

   chr = 'N';

   if ( please_NO_confirmation && ( wait == 0 ) )
      chr = 'Y';

   while( wait )
   {
      i = check_key_available(); // check for key
      if( i )
      {
         // a keyboard character is waiting - get it
         chr = _getch();
         return chr;
      }

      Sleep(55);

      if( please_NO_confirmation )
      {
         if( wait > 55 )
         {
            wait -= 55;
         }
         else
         {
            chr = 'Y';  // simulate a 'Y' keyboard
            wait = 0;   // and the WAIT IS OVER
         }
      }
   }

   return chr;
}

// this WAITS
int check_stdin_available( void )
{
   int iret = 0;
   char chBuffer[1];
   DWORD cRead;
   OVERLAPPED ol;
   HANDLE hStdin = GetStdHandle(STD_INPUT_HANDLE);

   ZeroMemory( &ol, sizeof(OVERLAPPED));
   if (! ReadFile( 
            hStdin,    // input handle 
            (LPVOID)chBuffer,  // buffer to read into 
            sizeof(chBuffer), // size of buffer 
            &cRead,    // actual bytes read 
            &ol) )    // not overlapped 
   {
      DWORD err = GetLastError();
      if( err == ERROR_IO_PENDING )
         iret = 1;
      return 0;
   }
   iret = chBuffer[0];
   return iret;
}

// this does NOT work!!!
int check_CONIN_available( void )
{
   FILE * hStdin = fopen( "CONIN$", "r" );
   if ( !hStdin )
      return 0;
   if ( feof(hStdin) )
      return 0;
   return 1;
}

// eof - xkey.cxx
